Opened 17 months ago

Closed 8 months ago

#2304 closed Bug (fixed)

SETTE failed to update some namelist parameter

Reported by: mathiot Owned by: mathiot
Priority: low Milestone:
Component: CI Version: trunk
Severity: minor Keywords:
Cc: smueller

Description (last modified by mathiot)

Context

SETTE failed to update the diaops namelist parameters specified for the OBS operator test. As a consequences, OBS operator is not tested by sette. It could also impact other namelist setting done by sette.

Analysis

set_namelist function finds the namelist group associated with a namelist variable using namelist_ref. If the namelist group is missing in namelist_cfg, set_namelist fails to edit the namelist and continue.

Fix

  • Add a test in set_namelist function on the presence of namelist group name in namelist_cfg and exit with an error if missing (it will stop the sette test).
                # check if namelist group present in namelist_cfg
                NGRP=$(grep ${NAMGRP} ${EXE_DIR}/$1 | wc -l )
                if [ ${NGRP} -eq 0 ]; then
                   echo ''
                   echo "+++++ Cannot update ${2} because group ${NAMGRP} is missing in ${EXE_DIR}/$1  +++++ "      
                   echo ''
                   exit 42
                fi
  • Add in all namelist_cfg the missing namelist groups. This will allow also a simple side by side comparison.
!-----------------------------------------------------------------------
&namxxx        ! xxxxxxxxxxx                      (xxxxxx)
!-----------------------------------------------------------------------
/

Additional work

  • add option to clean sette configuration using ./makenemo clean : sette.sh -c
  • add option to synchronize EXPREF/MY_SRF in the reference configuration directory with EXP00/MY_SRC in the sette configuration directory : sette.sh -s
  • add option to select the compiler in sette_list_avail_rev.sh : sette_list_avail_rev.sh -c XXXX
  • add option to select the compiler in sette_rpt.sh. So in addition of the former syntax (./sette_rpt.sh ; ./sette_rpt.sh xxxx) these option are available : ./sette_rpt.sh -c COMPILER ; ./sette_rpt.sh -c COMPILER xxxx ; ./sette_rpt.sh -c COMPILER -r xxxx

This work should :

  • ease the usage of sette especially after big changes (like a merge where namelist, MY_SRC and src files added or deleted).
  • ease the work to retreive sette results from other compiler (production/debug) or dig into the sette history.

Commit History (15)

ChangesetAuthorTimeChangeLog
12571mathiot2020-03-18T15:35:09+01:00

ticket #2304: delete branch

12569mathiot2020-03-18T12:22:56+01:00

ticket #2304: merge branch sette_ticket2304 into sette (thank you Simon for the review and all the suggestions you made). It include synchronisation and cleaning option between the REF config and the _ST config to ease the work when the reference configurations are changed and display bug in sette_check_avail_rev

12562mathiot2020-03-17T11:28:13+01:00

ticket #2304: cosmetic change in the display of the list of all available revision

12561mathiot2020-03-17T11:23:35+01:00

ticket #2304: add LC_MESSAGES definition in param (only en_US supported)

12541mathiot2020-03-12T18:05:24+01:00

ticket #2304 : add description of -s and -c in the README, set verbosity of rsync to normal and update text output from sette

12508mathiot2020-03-04T17:00:49+01:00

ticket #2304 : change in display output, synchrose all files that are not links instead of a selection of files as there is no consistancy in the various EXPREF between what is link or not, touch source files after synchronisation to trigger compilation in the unlikely case where source in CFG/MY_SRC is more recent than in REF/MY_SRC

12505mathiot2020-03-03T15:15:48+01:00

#2304 : fix issues related to MY_SRC synchronisation when files are removed

12445mathiot2020-02-24T15:17:53+01:00

update to the head of sette (ticket #2304)

12444mathiot2020-02-24T15:14:49+01:00

Corrections after Simon review: add AGRIF context file in the synchronisation, update sette_rpt.sh to keep old and new usage available, update sette comments and issue with old set as revision in get_dorv (ticket #2304)

12295mathiot2019-12-30T19:49:11+01:00

add time step number when result start to be different to the reference (ticket #2304)

12290mathiot2019-12-30T17:12:30+01:00

use rsync for sync instead of cp and remove sync of cpp key (ticket #2304)

12289mathiot2019-12-30T16:31:18+01:00

as suggested by Simon, instead of stopping sette if namelist group is missing, we now add it at the end of the namelist + rm useless line in sette_list_avail_rev.sh + add syncronisation of MY_SRC, namelist_cfg, xml, cppkey files between REF and _ST (ticket #2304)

12238mathiot2019-12-13T10:27:58+01:00

stop sette execution if one of the namelist variable cannot be updated in namelist cfg because of missing namelist group #2304

12237mathiot2019-12-13T10:21:07+01:00

fix issue in sette_list_avail_rev in case multiple compiler sette results #2304

12235mathiot2019-12-13T10:16:43+01:00

fix typo in FAILED message #2304

Change History (20)

comment:1 Changed 12 months ago by mathiot

  • Resolution set to fixed
  • Status changed from new to closed

In 12234:

build branch to fix ticket 2304

comment:2 Changed 12 months ago by mathiot

In 12235:

fix typo in FAILED message #2304

comment:3 Changed 12 months ago by mathiot

In 12237:

fix issue in sette_list_avail_rev in case multiple compiler sette results #2304

comment:4 Changed 12 months ago by mathiot

In 12238:

stop sette execution if one of the namelist variable cannot be updated in namelist cfg because of missing namelist group #2304

comment:5 Changed 11 months ago by mathiot

In 12289:

as suggested by Simon, instead of stopping sette if namelist group is missing, we now add it at the end of the namelist + rm useless line in sette_list_avail_rev.sh + add syncronisation of MY_SRC, namelist_cfg, xml, cppkey files between REF and _ST (ticket #2304)

comment:6 Changed 11 months ago by mathiot

In 12290:

use rsync for sync instead of cp and remove sync of cpp key (ticket #2304)

comment:7 Changed 11 months ago by mathiot

In 12295:

add time step number when result start to be different to the reference (ticket #2304)

comment:8 Changed 9 months ago by mathiot

In 12444:

Corrections after Simon review: add AGRIF context file in the synchronisation, update sette_rpt.sh to keep old and new usage available, update sette comments and issue with old set as revision in get_dorv (ticket #2304)

comment:9 Changed 9 months ago by mathiot

In 12445:

update to the head of sette (ticket #2304)

comment:10 Changed 9 months ago by mathiot

  • Description modified (diff)
  • Resolution fixed deleted
  • Status changed from closed to reopened

Ticket closed by mistake during the branch creation.

comment:11 Changed 9 months ago by mathiot

In 12505:

#2304 : fix issues related to MY_SRC synchronisation when files are removed

comment:12 Changed 9 months ago by mathiot

In 12508:

ticket #2304 : change in display output, synchrose all files that are not links instead of a selection of files as there is no consistancy in the various EXPREF between what is link or not, touch source files after synchronisation to trigger compilation in the unlikely case where source in CFG/MY_SRC is more recent than in REF/MY_SRC

comment:13 Changed 9 months ago by smueller

  • Cc smueller added

comment:14 Changed 9 months ago by mathiot

In 12541:

ticket #2304 : add description of -s and -c in the README, set verbosity of rsync to normal and update text output from sette

comment:15 Changed 8 months ago by mathiot

In 12561:

ticket #2304: add LC_MESSAGES definition in param (only en_US supported)

comment:16 Changed 8 months ago by mathiot

In 12562:

ticket #2304: cosmetic change in the display of the list of all available revision

comment:17 Changed 8 months ago by mathiot

In 12568:

ticket2304: synchronise branch with lates revision of sette

comment:18 Changed 8 months ago by mathiot

In 12569:

ticket #2304: merge branch sette_ticket2304 into sette (thank you Simon for the review and all the suggestions you made). It include synchronisation and cleaning option between the REF config and the _ST config to ease the work when the reference configurations are changed and display bug in sette_check_avail_rev

comment:19 Changed 8 months ago by mathiot

In 12571:

ticket #2304: delete branch

comment:20 Changed 8 months ago by mathiot

  • Resolution set to fixed
  • Status changed from reopened to closed
Note: See TracTickets for help on using tickets.